# $Revision: 1.40 $, $Date: 2011/11/25 14:49:56 $
# TODO:
#  - package for ruby API
#  - subpackage for driver backend deps if code patched to support it:
#    sphinx-0.9.9-2.i686: required "libodbc.so.1" is provided by following packages:
#    libmysqlclient.so.16 libmysqlclient.so.16(libmysqlclient_16) libpq.so.5
#
# Conditional build:
%bcond_without	java		# without Java support
%bcond_without	libstemmer	# without libstemmer support
%bcond_without	mysql		# without MySQL support
%bcond_without	pgsql		# without PostgreSQL support

%undefine	with_java

%{?with_java:%include	/usr/lib/rpm/macros.java}
%include	/usr/lib/rpm/macros.php
%define		php_min_version 5.0.4
Summary:	Free open-source SQL full-text search engine
Summary(pl.UTF-8):	Silnik przeszukiwania pełnotekstowego SQL open-source
Name:		sphinx
Version:	0.9.9
Release:	8
License:	GPL v2
Group:		Applications/Databases
Source0:	http://www.sphinxsearch.com/downloads/%{name}-%{version}.tar.gz
# Source0-md5:	7b9b618cb9b378f949bb1b91ddcc4f54
Source1:	%{name}.init
Source2:	%{name}.logrotate
Source3:	%{name}.conf.sh
Patch0:		%{name}-system-libstemmer.patch
Patch1:		bug-468.patch
Patch2:		bug-297.patch
URL:		http://www.sphinxsearch.com/
BuildRequires:	autoconf
BuildRequires:	automake
BuildRequires:	expat-devel
%{?with_java:BuildRequires:	jdk}
BuildRequires:	libstdc++-devel
%{?with_libstemmer:BuildRequires:	libstemmer-devel}
BuildRequires:	libtool
%{?with_mysql:BuildRequires:	mysql-devel}
%{?with_pgsql:BuildRequires:	postgresql-devel}
BuildRequires:	python
BuildRequires:	python-modules
BuildRequires:	rpm-javaprov
BuildRequires:	rpm-php-pearprov >= 4.4.2-11
BuildRequires:	rpm-pythonprov
BuildRequires:	rpmbuild(macros) >= 1.461
Requires(postun):	/usr/sbin/groupdel
Requires(postun):	/usr/sbin/userdel
Requires(pre):	/bin/id
Requires(pre):	/usr/bin/getgid
Requires(pre):	/usr/sbin/groupadd
Requires(pre):	/usr/sbin/useradd
Provides:	group(sphinx)
Provides:	user(sphinx)
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%define		_sysconfdir	/etc/%{name}

%description
Sphinx is a a standalone search engine, meant to provide fast,
size-efficient and relevant fulltext search functions to other
applications. Sphinx was specially designed to integrate well with SQL
databases and scripting languages. Currently built-in data sources
support fetching data either via direct connection to MySQL, or from
an XML pipe.

%description -l pl.UTF-8
Sphinx jest samodzielnym silnikiem przeszukującym, dostarczającym
innym aplikacjom szybkie, zoptymalizowane rozmiarowo funkcje
przeszukiwania pełnotekstowego. Sphinx został specjalnie
zaprojektowany z myślą o dobrej integracji z bazami danych SQL oraz
językami skryptowymi. Obecnie wbudowane źródła danych wspierają
pobieranie danych poprzez bezpośrednie połączenie z MySQL lub z potoku
XML.

%package -n libsphinxclient
Summary:	Client library for Sphinx
Summary(pl.UTF-8):	Biblioteka kliencka do Sphinx
Group:		Libraries

%description -n libsphinxclient
This package provides a client library for Sphinx search engine.

%description -n libsphinxclient -l pl.UTF-8
Ten pakiet dostarcza bibliotekę kliencką do silnika Sphinx.

%package -n libsphinxclient-devel
Summary:	Header files for sphinxclient library
Summary(pl.UTF-8):	Pliki nagłówkowe biblioteki sphinxclient
Group:		Development/Libraries
Requires:	libsphinxclient = %{version}-%{release}

%description -n libsphinxclient-devel
Header files for sphinxclient library.

%description -n libsphinxclient-devel -l pl.UTF-8
Pliki nagłówkowe biblioteki sphinxclient.

%package -n libsphinxclient-static
Summary:	Static sphinxclient library
Summary(pl.UTF-8):	Statyczna biblioteka sphinxclient
Group:		Development/Libraries
Requires:	libsphinxclient-devel = %{version}-%{release}

%description -n libsphinxclient-static
Static sphinxclient library.

%description -n libsphinxclient-static -l pl.UTF-8
Statyczna biblioteka sphinxclient.

%package -n java-sphinx
Summary:	Java API for Sphinx
Summary(pl.UTF-8):	API Javy dla Sphinksa
Group:		Development/Languages/Java
Requires:	jpackage-utils

%description -n java-sphinx
Java API for Sphinx.

%description -n java-sphinx -l pl.UTF-8
API Javy dla Sphinksa.

%package -n php-sphinx
Summary:	PHP API for Sphinx
Summary(pl.UTF-8):	API PHP dla Sphinksa
Group:		Libraries
Requires:	php-common >= 4:%{php_min_version}
Provides:	php(sphinx)

%description -n php-sphinx
PHP API for Sphinx.

%description -n php-sphinx -l pl.UTF-8
API PHP dla Sphinksa.

%package -n python-sphinx
Summary:	Python API for Sphinx
Summary(pl.UTF-8):	API Python dla Sphinksa
Group:		Development/Languages/Python
%pyrequires_eq	python

%description -n python-sphinx
Python API for Sphinx.

%description -n python-sphinx -l pl.UTF-8
API Pythona dla Sphinksa.

%prep
%setup -q
%patch0 -p1
%patch1 -p1
%patch2 -p1

sed -i -e '
	s#/var/run/#/var/run/sphinx/#
	s#@CONFDIR@/log/searchd.pid#/var/run/sphinx/searchd.pid#
	s#@CONFDIR@/log/#/var/log/sphinx/#g
	s#@CONFDIR@/data/#/var/lib/sphinx/#g
' sphinx*.conf.in

%build
%{__aclocal}
%{__autoconf}
%{__autoheader}
%{__automake}
CPPFLAGS=-D_FILE_OFFSET_BITS=64
%configure \
	--with%{!?with_libstemmer:out}-libstemmer \
	--with%{!?with_pgsql:out}-pgsql \
	--with%{!?with_mysql:out}-mysql
%{__make} -j1
# use .conf ext for %doc
cp -f sphinx.conf.dist sphinx.conf
cp -f sphinx-min.conf.dist sphinx-min.conf

# libsphinxclient
cd api/libsphinxclient
%{__libtoolize}
%{__aclocal}
%{__autoconf}
%{__autoheader}
%{__automake}
CPPFLAGS=-D_FILE_OFFSET_BITS=64
%configure
%{__make} -j1
cd ../..

# java api
%if %{with java}
export JAVA_HOME="%{java_home}"
%{__make} -j1 -C api/java
%endif

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT{%{_sbindir},/etc/{logrotate.d,rc.d/init.d},/var/{log,run,lib}/%{name},/var/log/archive/%{name}}

%{__make} -j1 install \
	DESTDIR=$RPM_BUILD_ROOT

rm $RPM_BUILD_ROOT%{_sysconfdir}/example.sql
rm $RPM_BUILD_ROOT%{_sysconfdir}/sphinx.conf.dist

# create default config with no index definition
sed -e '/## data source definition/,/## indexer settings/d' sphinx.conf > $RPM_BUILD_ROOT%{_sysconfdir}/sphinx-common.conf
# dir for indexes definition
install -d $RPM_BUILD_ROOT%{_sysconfdir}/index.d

rm $RPM_BUILD_ROOT%{_sysconfdir}/sphinx-min.conf.dist
mv $RPM_BUILD_ROOT{%{_bindir},%{_sbindir}}/searchd
install -p %{SOURCE1} $RPM_BUILD_ROOT/etc/rc.d/init.d/%{name}
cp -p %{SOURCE2} $RPM_BUILD_ROOT/etc/logrotate.d/%{name}
install -p %{SOURCE3} $RPM_BUILD_ROOT%{_sysconfdir}/%{name}.conf

install -d $RPM_BUILD_ROOT%{php_data_dir}
cp -p api/sphinxapi.php $RPM_BUILD_ROOT%{php_data_dir}

# libsphinxclient
%{__make} -C api/libsphinxclient install \
	DESTDIR=$RPM_BUILD_ROOT

# python api
install -d $RPM_BUILD_ROOT%{py_sitescriptdir}
cp -p api/sphinxapi.py $RPM_BUILD_ROOT%{py_sitescriptdir}
%py_comp $RPM_BUILD_ROOT%{py_sitescriptdir}
%py_ocomp $RPM_BUILD_ROOT%{py_sitescriptdir}
%py_postclean

# ruby api

# java api
%if %{with java}
install -d $RPM_BUILD_ROOT%{_javadir}
cp -p api/java/sphinxapi.jar $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}.jar
ln -s %{name}-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}.jar
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%post	-n libsphinxclient -p /sbin/ldconfig
%postun	-n libsphinxclient -p /sbin/ldconfig

%pre
%groupadd -g 249 sphinx
%useradd -u 249 -d /var/lib/%{name} -g sphinx -c "Sphinx Search" sphinx

%post
/sbin/chkconfig --add sphinx
%service sphinx restart

%preun
if [ "$1" = 0 ]; then
	%service sphinx stop
	/sbin/chkconfig --del sphinx
fi

%triggerpostun -- %{name} < 0.9.9-7.6
if [ -f %{_sysconfdir}/sphinx.conf.rpmsave ]; then
	cp -f %{_sysconfdir}/sphinx-common.conf{,.rpmnew}
	mv -f %{_sysconfdir}/sphinx.conf.rpmsave %{_sysconfdir}/sphinx-common.conf
	%service -q sphinx restart
fi

%files
%defattr(644,root,root,755)
%doc doc/sphinx.txt example.sql sphinx.conf sphinx-min.conf

%dir %attr(750,root,sphinx) %{_sysconfdir}
# main sphinx config
%config(noreplace) %verify(not md5 mtime size) %attr(640,root,sphinx) %{_sysconfdir}/sphinx-common.conf
# shell wrapper which loads main config and extra indexes config
%attr(755,root,sphinx) %{_sysconfdir}/sphinx.conf
# put here *.conf files defining extra indexes
%dir %attr(750,root,sphinx) %{_sysconfdir}/index.d

%config(noreplace) %verify(not md5 mtime size) /etc/logrotate.d/%{name}
%attr(754,root,root) /etc/rc.d/init.d/%{name}
%attr(755,root,root) %{_bindir}/indexer
%attr(755,root,root) %{_bindir}/indextool
%attr(755,root,root) %{_bindir}/search
%attr(755,root,root) %{_bindir}/spelldump
%attr(755,root,root) %{_sbindir}/searchd

%dir %attr(771,root,sphinx) /var/run/sphinx
%dir %attr(770,root,sphinx) /var/log/sphinx
%dir %attr(770,root,sphinx) /var/log/archive/sphinx
%dir %attr(770,root,sphinx) /var/lib/sphinx

%files -n libsphinxclient
%defattr(644,root,root,755)
%doc api/libsphinxclient/README
%attr(755,root,root) %{_libdir}/libsphinxclient-*.*.*.so

%files -n libsphinxclient-devel
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/libsphinxclient.so
%{_libdir}/libsphinxclient.la
%{_includedir}/*.h

%files -n libsphinxclient-static
%defattr(644,root,root,755)
%{_libdir}/libsphinxclient.a

%if %{with java}
%files -n java-sphinx
%defattr(644,root,root,755)
%doc api/java/README
%{_javadir}/sphinx*.jar
%endif

%files -n php-sphinx
%defattr(644,root,root,755)
%{php_data_dir}/sphinxapi.php

%files -n python-sphinx
%defattr(644,root,root,755)
%{py_sitescriptdir}/*.py[co]

%define date	%(echo `LC_ALL="C" date +"%a %b %d %Y"`)
%changelog
* %{date} PLD Team <feedback@pld-linux.org>
All persons listed below can be reached at <cvs_login>@pld-linux.org

$Log: sphinx.spec,v $
Revision 1.40  2011/11/25 14:49:56  glen
- add include support from main config; trigger included, but you need to start daemon after upgrade

Revision 1.39  2011/03/31 18:13:07  arekm
- release 7

Revision 1.38  2011/02/09 10:34:11  glen
- 0000297: indexer --rotate causes non-recoverable lock failure occasionally

Revision 1.37  2011/02/05 01:12:26  sparky
- corrected lang tag in %description

Revision 1.36  2010/07/09 11:24:43  arekm
- release 5

Revision 1.35  2010/06/16 18:00:34  glen
- release 4

Revision 1.34  2010/06/14 17:33:56  glen
- php-sphinx provides php(sphinx) virtual (there exists pecl ext as well)

Revision 1.33  2010/06/14 17:31:49  glen
- php class does not use mbstring, only workarounds if mbstring.func_overload is set

Revision 1.32  2010/06/14 13:17:59  glen
- release 3

Revision 1.31  2010/06/14 13:05:00  glen
- secure sphinx.config, may contain passwords

Revision 1.30  2010/05/13 20:01:49  glen
- release 2

Revision 1.29  2010/05/12 20:41:46  sparky
- BR: libtool, python, python-modules, rpm-pythonprov

Revision 1.28  2010/04/17 07:44:35  jajcus
- do not pull java-sun via BR - icedtea6 should be enough in all (most) cases

Revision 1.27  2010/04/12 11:49:09  glen
- add log archive dir

Revision 1.26  2010/04/12 11:46:32  glen
- add logrotate, inspired from fc

Revision 1.25  2010/04/12 11:42:39  glen
- add sphinx /var dirs

Revision 1.24  2010/04/12 11:28:30  glen
- package clean config

Revision 1.23  2010/03/30 22:24:28  glen
- add sphinx user, add build fix patch

Revision 1.22  2010/03/30 21:04:05  glen
- up to 0.9.9

Revision 1.21  2010/03/30 20:58:52  glen
- php deps

Revision 1.20  2010/03/30 19:57:05  glen
- disable java where java-sun is not available; rel 2

Revision 1.19  2009/10/28 20:31:25  arekm
- parallel build broken

Revision 1.18  2009/10/28 20:31:01  arekm
- up to 0.9.8.1

Revision 1.17  2008/10/26 14:41:39  glen
- php_data_dir

Revision 1.16  2008/08/17 19:29:58  qboosh
- pl fix
- no files duplicate

Revision 1.15  2008/08/03 20:36:27  adamg
- updated to 0.9.8
- mysql bcond
- proper mysql/pgsql bcond handling
- libstemmer support + bcond
- java bcond
- python api package
- libsphinxclient (+devel and static) packages

Revision 1.14  2008-01-03 14:52:51  qboosh
- pl for java-

Revision 1.13  2008-01-02 08:53:46  glen
- 0.9.8-svn-r985, add java api

Revision 1.12  2007-05-26 23:49:10  qboosh
- pl and defattr for php-

Revision 1.11  2007/05/24 08:58:46  glen
- created php-sphinx

Revision 1.10  2007/05/15 13:10:56  glen
- add initscript (NFY) and moved searchd to sbindir

Revision 1.9  2007/04/17 13:59:10  glen
- adapter

Revision 1.8  2007/04/17 13:58:10  glen
- 0.9.7-release

Revision 1.7  2007/03/16 17:18:16  qboosh
- bcond header

Revision 1.6  2007/03/16 10:59:04  glen
- correct conditional, -devel implies -libs

Revision 1.5  2007/03/16 08:15:24  beorn
- Bcond without pgsql added
- Added missing R: and BR:

Revision 1.4  2007/03/15 18:19:37  glen
- with-pgsql (not tested)

Revision 1.3  2007/03/15 17:48:21  glen
- _FILE_OFFSET_BITS=64 for proper build (thx to Andrew Aksyonoff for pointing to right direction)

Revision 1.2  2007/03/13 11:53:14  beorn
- Polish translation

Revision 1.1  2007/03/13 08:59:19  glen
- new
